<template>
  <q-dialog
    ref="dialog"
    @hide="$emit('hide')"
  >
    <q-card
      class="q-dialog-plugin"
      :style="{ minWidth: '800px' }"
    >
      <q-card-section horizontal>
        <q-card-section class="col q-pa-lg">
          <div class="column flex-center fit bg-grey-3">
            <div class="text-h2 text-weight-bolder text-blue-grey-9">
              {{ total | formatValue }}
            </div>

            <div
              class="text-subtitle2 text-bold text-grey text-uppercase"
              v-text="'Nota Total'"
            />
          </div>
        </q-card-section>

        <q-separator
          vertical
          inset
        />

        <q-card-section class="col-8">
          <div
            v-for="key in Object.keys(info)"
            :key="key"
          >
            <div class="q-pa-md">
              <div class="row justify-between q-pb-xs">
                <div
                  class="text-caption text-dark"
                  v-text="label[key]"
                />

                <div class="text-caption text-blue">
                  {{ Number(info[key].value) | formatValue }}/200,00
                </div>
              </div>

              <q-linear-progress
                :value="Number(info[key].value) / 200"
                color="blue-4"
                size="md"
                rounded
              />
            </div>
          </div>
        </q-card-section>
      </q-card-section>

      <q-separator inset />

      <q-card-section>
        <div
          class="text-h4 text-weight-bolder text-center text-blue-grey-9"
          v-text="'Correção no modelo ENEM'"
        />
      </q-card-section>

      <q-card-section>
        <q-markup-table
          separator="none"
          wrap-cells
          flat
        >
          <thead>
            <tr>
              <th class="text-left">
                <div
                  class="text-subtitle1 text-bold text-grey-5"
                  v-text="'COMPETÊNCIA'"
                />
              </th>

              <th class="text-center">
                <div
                  class="text-subtitle1 text-bold text-grey-5"
                  v-text="'NOTA'"
                />
              </th>

              <th class="text-left">
                <div
                  class="text-subtitle1 text-bold text-grey-5"
                  v-text="'COMENTÁRIO'"
                />
              </th>
            </tr>
          </thead>

          <tbody>
            <tr
              v-for="key in Object.keys(info)"
              :key="key"
            >
              <td class="text-left">
                <div
                  class="text-caption text-bold text-red text-uppercase"
                  v-text="label[key]"
                />

                <div v-text="text[key]" />
              </td>

              <td class="text-center">
                <div class="text-h5 text-bold text-blue-grey-9">
                  {{ info[key].value | formatValue }}
                </div>
              </td>

              <td class="text-left">
                <div v-text="info[key].comment" />
              </td>
            </tr>
          </tbody>
        </q-markup-table>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script>
import { formatToNumber } from 'brazilian-values'

export default {
  name: 'DialogRating',
  filters: {
    formatValue (value) {
      try {
        return !formatToNumber(value).includes(',')
          ? formatToNumber(value) + ',00'
          : formatToNumber(value)
      } catch (e) {
        return value
      }
    }
  },
  props: {
    info: {
      type: Object,
      required: true
    }
  },
  data () {
    return {
      label: {
        competence1: 'Competência I',
        competence2: 'Competência II',
        competence3: 'Competência III',
        competence4: 'Competência IV',
        competence5: 'Competência V'
      },
      text: {
        competence1: 'Demonstrar domínio da modalidade escrita formal da língua portuguesa.',
        competence2: 'Compreender a proposta de redação e aplicar conceitos das várias áreas de conhecimento para desenvolver o tema, dentro dos limites estruturais do texto dissertativo-argumentativo em prosa.',
        competence3: 'Selecionar, relacionar, organizar e interpretar informações, fatos, opiniões e argumentos em defesa de um ponto de vista.',
        competence4: 'Demonstrar conhecimento dos mecanismos linguísticos necessários para a construção da argumentação.',
        competence5: 'Elaborar proposta de intervenção para o problema abordado que respeite os direitos humanos.'
      }
    }
  },
  computed: {
    total () {
      let sum = 0

      Object.keys(this.info).forEach(key => (sum += Number(this.info[key].value)))

      return sum
    }
  },
  methods: {
    show () {
      this.$refs.dialog.show()
    },
    hide () {
      this.$refs.dialog.hide()
    }
  }
}
</script>
